Lanson编程技术分享

Lanson编程技术分享

CentOS7 php7.0 升级到php7.3

不要问我为什么要升级,我不是运维。如果你也不是运维的话,而且是公司的服务器的话,那你还是要慎重啊,我他么的就这样填了一天的坑,简单记录一下这坑爹的一天

备份之前的php7.0(这很重要,非常重要)

如果这一步没有做的话,直接升级,我敢确定90% 你服务器就挂了,至于为什么呢,因为你之前的配置都没有了呗,而新安装的php7.3 配置是新的,没有了各种扩展,你服务器怎么跑起来。当然如果你什么扩展都没有安装,恭喜你,你可以不用备份

cp -P /usr/local/php /usr/local/php70

查看php7.0的configure

既然是升级,当然configure只能比以前多而不能少了,如果你忘记了以前的configure(肯定没人记得),查看phpinfo

php -i | grep configure

替换一下就可以获得之前的configure 命令

php -i | grep configure | sed -e "s/Configure Command => //; s/'//g"

注意:php7.3不支持 --with-mcrypt, --enable-gd-native-ttf,把这两个选项删除掉。 

编译zlib时提示:configure: error: Please reinstall the libzip distributio 或者 configure: error: system libzip must be upgraded to version >= 0.11
使用Yum最新版只到0.10,不足以达到要求

可升级libzip:点击教程

下载php7.3源码

cd /usr/local/src
wget -c https://www.php.net/distributions/php-7.3.13.tar.gz -O php-7.3.13.tar.gz

tar -zxvf php-7.3.13.tar.gz
cd php-7.3.13/

开始安装7.3

cd php-7.3.13

./configure  --prefix=/usr/local/php --with-config-file-path=/usr/local/php/etc --with-config-file-scan-dir=/usr/local/php/conf.d --enable-fpm --with-fpm-user=www --with-fpm-group=www --enable-mysqlnd --with-mysqli=mysqlnd --with-pdo-mysql=mysqlnd --with-iconv-dir --with-freetype-dir=/usr/local/freetype --with-jpeg-dir --with-png-dir --with-zlib --with-libxml-dir=/usr --enable-xml --disable-rpath --enable-bcmath --enable-shmop --enable-sysvsem --enable-inline-optimization --with-curl --enable-mbregex --enable-mbstring --enable-intl --enable-ftp --with-gd --with-openssl --with-mhash --enable-pcntl --enable-sockets --with-xmlrpc --enable-zip --enable-soap --with-gettext --disable-fileinfo --enable-opcache --with-xsl

make 

make install

这样基本就安装完成了,简单吧,是很简单,但是坑来了

过程中可能出现:make: *** [sapi/cli/php] Error 1

解决方法:make ZEND_EXTRA_LIBS='-liconv'

开始填坑

既然是升级,配置当然和以前一样就好了

cp /usr/local/php70/etc/php.ini /usr/local/php/etc/php.ini
cp /usr/local/php70/etc/php-fpm.conf /usr/local/php/etc/php-fpm.conf
cp /usr/local/php70/etc/php-fpm.d/www.conf /usr/local/php/etc/php-fpm.d/www.conf

扩展的坑,以前装了什么扩展,现在都要重新安装了,而且不能在以前的扩展包文件夹下安装,必须是新的扩展包文件夹,这很重要,不然你一直执行php -v 都有类似下面的问题

PHP Warning: PHP Startup: Unable to load dynamic library'/usr/local/php7/lib/php/extensions/no-debug-non-zts-20160303/memcached.so' - /usr/local/php7/lib/php/extensions/no-debug-non-zts-20160303/memcached.so: cannot open sharedobject file: No such file or directory in Unknown on line 0

如果忘记安装了什么扩展,看一下扩展目录有什么就行了:

[root]$ /usr/local/php/bin/php-config --extension-dir
 /usr/local/php7/lib/php/extensions/no-debug-non-zts-20160303
[root]$  ls /usr/local/php7/lib/php/extensions/no-debug-non-zts-20160303
 

其中opcache.a opcache.so 是自带的,其他的都是新增的。其他扩展怎么装,就不告诉你了,如果你其他扩展装的很多的话,那恭喜你,你又可以好好练一遍了

重新启动php-fpm

systemctl restart php-fpm

查看状态

systemctl status php-fpm -l

剩下的坑,代码的坑

这个就有点丢脸了,如果你代码写的不怎么严谨的话,估计error.log 现在已经很大了,剩下很长一段时间你的又要修自己的代码了。我为什么把这个拿出来说呢,主要是我他么一天都在改这个兼容代码?(代码写的太烂)。比如单例一个类就爆出一个巨坑。。。。。祝你们好运

发表评论:

◎欢迎参与讨论,请在这里发表您的看法、交流您的观点。

网站分类
    «   2020年5月   »
    123
    45678910
    11121314151617
    18192021222324
    25262728293031
    文章归档
    友情链接
    最近发表
    标签列表

      Powered By Z-BlogPHP 1.5.2 Zero

      版权所有 ©Lanson编程技术 粤ICP备18051278-1号